/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.160
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.21 2009/02/14 22:25:10 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.160 2015/03/11 14:07:56 dlan Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator 12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
15 16
16IUSE="${IUSE} custom-cxxflags debug pch" 17inherit eutils flag-o-matic multilib toolchain-funcs
17 18
19HOMEPAGE="https://www.qt.io/ https://qt-project.org/"
20LICENSE="|| ( LGPL-2.1 GPL-3 )"
21SLOT="4"
22
18case "${PV}" in 23case ${PV} in
19 4.?.?_rc*) 24 4.?.9999)
20 SRCTYPE="${SRCTYPE:-opensource-src}" 25 QT4_BUILD_TYPE="live"
21 MY_PV="${PV/_rc/-rc}" 26 EGIT_REPO_URI=(
27 "git://gitorious.org/qt/qt.git"
28 "https://git.gitorious.org/qt/qt.git"
29 )
30 EGIT_BRANCH=${PV%.9999}
31 inherit git-r3
22 ;; 32 ;;
23 *) 33 *)
24 SRCTYPE="${SRCTYPE:-opensource-src}" 34 QT4_BUILD_TYPE="release"
25 MY_PV="${PV}" 35 MY_P=qt-everywhere-opensource-src-${PV/_/-}
36 SRC_URI="http://download.qt.io/archive/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
37 S=${WORKDIR}/${MY_P}
26 ;; 38 ;;
27esac 39esac
28MY_P=qt-x11-${SRCTYPE}-${MY_PV}
29S=${WORKDIR}/${MY_P}
30 40
31HOMEPAGE="http://www.qtsoftware.com/" 41IUSE="aqua debug pch"
32SRC_URI="ftp://ftp.trolltech.com/qt/source/${MY_P}.tar.bz2" 42[[ ${PN} != qtxmlpatterns ]] && IUSE+=" +exceptions"
33 43
34case "${PV}" in 44DEPEND="virtual/pkgconfig"
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;; 45if [[ ${QT4_BUILD_TYPE} == live ]]; then
36 *) ;; 46 DEPEND+=" dev-lang/perl"
37esac 47fi
38 48
49# @FUNCTION: qt4-build_pkg_setup
50# @DESCRIPTION:
51# Sets up PATH and LD_LIBRARY_PATH.
39qt4-build_pkg_setup() { 52qt4-build_pkg_setup() {
40 # EAPI=2 ebuilds set use-deps, others need this: 53 # Warn users of possible breakage when downgrading to a previous release.
41 if [[ $EAPI != 2 ]]; then 54 # Downgrading revisions within the same release is safe.
42 # Make sure debug setting corresponds with qt-core (bug 258512) 55 if has_version ">${CATEGORY}/${P}-r9999:4"; then
43 if [[ $PN != "qt-core" ]]; then 56 ewarn
44 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 57 ewarn "Downgrading Qt is completely unsupported and can break your system!"
45 ~x11-libs/qt-core-${PV} debug" 58 ewarn
59 fi
60
61 PATH="${S}/bin${PATH:+:}${PATH}"
62 if [[ ${CHOST} != *-darwin* ]]; then
63 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
64 else
65 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
66 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
67 # platform detection. Note: needs to come before any directories to
68 # avoid extract failure.
69 [[ ${CHOST} == *-apple-darwin* ]] && \
70 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
71 ${QT4_EXTRACT_DIRECTORIES}"
72 fi
73}
74
75# @ECLASS-VARIABLE: PATCHES
76# @DEFAULT_UNSET
77# @DESCRIPTION:
78# Array variable containing all the patches to be applied. This variable
79# is expected to be defined in the global scope of ebuilds. Make sure to
80# specify the full path. This variable is used in src_prepare phase.
81#
82# Example:
83# @CODE
84# PATCHES=(
85# "${FILESDIR}/mypatch.patch"
86# "${FILESDIR}/patches_folder/"
87# )
88# @CODE
89
90# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Space-separated list of directories that will be extracted
94# from Qt tarball.
95
96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DEFAULT_UNSET
98# @DESCRIPTION:
99# Space-separated list of directories that will be configured,
100# compiled, and installed. All paths must be relative to ${S}.
101
102# @FUNCTION: qt4-build_src_unpack
103# @DESCRIPTION:
104# Unpacks the sources.
105qt4-build_src_unpack() {
106 setqtenv
107
108 if [[ $(gcc-major-version) -lt 4 ]] || [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ]]; then
109 ewarn
110 ewarn "Using a GCC version lower than 4.4 is not supported."
111 ewarn
112 fi
113
114 if [[ ${PN} == qtwebkit ]]; then
115 eshopts_push -s extglob
116 if is-flagq '-g?(gdb)?([1-9])'; then
117 ewarn
118 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
119 ewarn "You may experience really long compilation times and/or increased memory usage."
120 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
121 ewarn "For more info check out https://bugs.gentoo.org/307861"
122 ewarn
46 fi 123 fi
124 eshopts_pop
125 fi
47 126
48 # Check USE requirements 127 case ${QT4_BUILD_TYPE} in
49 qt4-build_check_use 128 live)
129 git-r3_src_unpack
130 ;;
131 release)
132 local tarball="${MY_P}.tar.gz" target= targets=
133 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
134 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
135 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
136 do
137 targets+="${MY_P}/${target} "
138 done
139
140 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
141 tar -xzf "${DISTDIR}/${tarball}" ${targets}
142 eend $? || die "failed to unpack"
143 ;;
144 esac
145}
146
147# @FUNCTION: qt4-build_src_prepare
148# @DESCRIPTION:
149# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
150# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
151qt4-build_src_prepare() {
152 setqtenv
153
154 if [[ ${QT4_BUILD_TYPE} == live ]]; then
155 QTDIR="." ./bin/syncqt || die "syncqt failed"
156 fi
157
158 # avoid X11 dependency in non-gui packages
159 local nolibx11_pkgs="qtbearer qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
160 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
161
162 if use aqua; then
163 # provide a proper macx-g++-64
164 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
165
166 sed -e '/^CONFIG/s:app_bundle::' \
167 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
168 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
169 fi
170
171 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
172 skip_qmake_build
173 skip_project_generation
174 symlink_binaries_to_buildtree
175 fi
176
177 if use_if_iuse c++0x; then
178 append-cxxflags -std=c++0x
179 fi
180
181 # Bug 261632
182 if use ppc64; then
183 append-flags -mminimal-toc
184 fi
185
186 # Bug 373061
187 # qmake bus errors with -O2 or -O3 but -O1 works
188 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 replace-flags -O[23] -O1
190 fi
191
192 # Bug 417105
193 # graphite on gcc 4.7 causes miscompilations
194 if [[ $(gcc-version) == "4.7" ]]; then
195 filter-flags -fgraphite-identity
196 fi
197
198 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
199 sed -e "/^SYSTEM_VARIABLES=/i \
200 CC='$(tc-getCC)'\n\
201 CXX='$(tc-getCXX)'\n\
202 CFLAGS='${CFLAGS}'\n\
203 CXXFLAGS='${CXXFLAGS}'\n\
204 LDFLAGS='${LDFLAGS}'\n\
205 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
206 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
207 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
208 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
209 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
211 -i configure \
212 || die "sed SYSTEM_VARIABLES failed"
213
214 # Respect CC, CXX, LINK and *FLAGS in config.tests
215 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
216 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
217 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
218 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
219 || die "sed config.tests failed"
220
221 # Bug 172219
222 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223
224 if [[ ${CHOST} == *-darwin* ]]; then
225 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
226 # crippled (by design) :/
227 local mac_gpp_conf=
228 if [[ -f mkspecs/common/mac-g++.conf ]]; then
229 # qt < 4.8 has mac-g++.conf
230 mac_gpp_conf="mkspecs/common/mac-g++.conf"
231 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
232 # qt >= 4.8 has g++-macx.conf
233 mac_gpp_conf="mkspecs/common/g++-macx.conf"
234 else
235 die "no known conf file for mac found"
50 fi 236 fi
237 sed \
238 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
239 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
240 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
241 -e "s:-arch\s\w*::g" \
242 -i ${mac_gpp_conf} \
243 || die "sed ${mac_gpp_conf} failed"
51 244
245 # Fix configure's -arch settings that appear in qmake/Makefile and also
246 # fix arch handling (automagically duplicates our -arch arg and breaks
247 # pch). Additionally disable Xarch support.
248 local mac_gcc_confs="${mac_gpp_conf}"
249 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
250 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
251 fi
252 sed \
253 -e "s:-arch i386::" \
254 -e "s:-arch ppc::" \
255 -e "s:-arch x86_64::" \
256 -e "s:-arch ppc64::" \
257 -e "s:-arch \$i::" \
258 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
259 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
260 -e "s:-Xarch_x86_64::g" \
261 -e "s:-Xarch_ppc64::g" \
262 -i configure ${mac_gcc_confs} \
263 || die "sed -arch/-Xarch failed"
264
265 # On Snow Leopard don't fall back to 10.5 deployment target.
266 if [[ ${CHOST} == *-apple-darwin10 ]]; then
267 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
268 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
269 -i configure ${mac_gpp_conf} \
270 || die "sed deployment target failed"
271 fi
272 fi
273
274 # this one is needed for all systems with a separate -liconv, apart from
275 # Darwin, for which the sources already cater for -liconv
276 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
277 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
278 -i config.tests/unix/iconv/iconv.pro \
279 || die "sed iconv.pro failed"
280 fi
281
282 # we need some patches for Solaris
283 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
284 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
285 # use GCC over SunStudio
286 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
287 # do not flirt with non-Prefix stuff, we're quite possessive
288 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
289 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
290
291 # apply patches
292 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
293 epatch_user
294}
295
296# @FUNCTION: qt4-build_src_configure
297# @DESCRIPTION:
298# Default configure phase
299qt4-build_src_configure() {
300 setqtenv
301
302 local conf="
303 -prefix ${QTPREFIXDIR}
304 -bindir ${QTBINDIR}
305 -libdir ${QTLIBDIR}
306 -docdir ${QTDOCDIR}
307 -headerdir ${QTHEADERDIR}
308 -plugindir ${QTPLUGINDIR}
309 -importdir ${QTIMPORTDIR}
310 -datadir ${QTDATADIR}
311 -translationdir ${QTTRANSDIR}
312 -sysconfdir ${QTSYSCONFDIR}
313 -examplesdir ${QTEXAMPLESDIR}
314 -demosdir ${QTDEMOSDIR}
315 -opensource -confirm-license
316 -shared -fast -largefile -stl -verbose
317 -nomake examples -nomake demos"
318
319 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
320 # $(tc-arch). Therefore we convert it to supported values.
321 case "$(tc-arch)" in
322 amd64|x64-*) conf+=" -arch x86_64" ;;
323 ppc-macos) conf+=" -arch ppc" ;;
324 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
325 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
326 x86-macos) conf+=" -arch x86" ;;
327 x86|x86-*) conf+=" -arch i386" ;;
328 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
329 arm64|hppa|sh) conf+=" -arch generic" ;;
330 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
331 esac
332
333 conf+=" -platform $(qt_mkspecs_dir)"
334
335 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
336
337 # debug/release
338 if use debug; then
339 conf+=" -debug"
340 else
341 conf+=" -release"
342 fi
343 conf+=" -no-separate-debug-info"
344
345 # exceptions USE flag
346 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
347
348 # disable rpath (bug 380415), except on prefix (bug 417169)
349 use prefix || conf+=" -no-rpath"
350
351 # precompiled headers don't work on hardened, where the flag is masked
352 conf+=" $(qt_use pch)"
353
354 # -reduce-relocations
355 # This flag seems to introduce major breakage to applications,
356 # mostly to be seen as a core dump with the message "QPixmap: Must
357 # construct a QApplication before a QPaintDevice" on Solaris.
358 # -- Daniel Vergien
359 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
360
361 # this one is needed for all systems with a separate -liconv, apart from
362 # Darwin, for which the sources already cater for -liconv
363 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
364 conf+=" -liconv"
365 fi
366
367 if use_if_iuse glib; then
368 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
369 # avoid the -pthread argument
370 conf+=" ${glibflags//-pthread}"
371 unset glibflags
372 fi
373
374 if use aqua; then
375 # On (snow) leopard use the new (frameworked) cocoa code.
376 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
377 conf+=" -cocoa -framework"
378 # We need the source's headers, not the installed ones.
379 conf+=" -I${S}/include"
380 # Add hint for the framework location.
381 conf+=" -F${QTLIBDIR}"
382
383 # We are crazy and build cocoa + qt3support :-)
384 if use qt3support; then
385 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
386 -i configure || die
387 fi
388 else
389 conf+=" -no-framework"
390 fi
391 else
392 # freetype2 include dir is non-standard, thus pass it to configure
393 conf+=" $(pkg-config --cflags-only-I freetype2)"
394 fi
395
396 conf+=" ${myconf}"
397 myconf=
398
399 echo ./configure ${conf}
400 ./configure ${conf} || die "./configure failed"
401
402 prepare_directories ${QT4_TARGET_DIRECTORIES}
403}
404
405# @FUNCTION: qt4-build_src_compile
406# @DESCRIPTION:
407# Actual compile phase
408qt4-build_src_compile() {
409 setqtenv
410
411 build_directories ${QT4_TARGET_DIRECTORIES}
412}
413
414# @FUNCTION: qt4-build_src_test
415# @DESCRIPTION:
416# Runs tests only in target directories.
417qt4-build_src_test() {
418 # QtMultimedia does not have any test suite (bug #332299)
419 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
420
421 for dir in ${QT4_TARGET_DIRECTORIES}; do
422 emake -j1 check -C ${dir}
423 done
424}
425
426# @FUNCTION: fix_includes
427# @DESCRIPTION:
428# For MacOS X we need to add some symlinks when frameworks are
429# being used, to avoid complications with some more or less stupid packages.
430fix_includes() {
431 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
432 local frw dest f h rdir
433 # Some packages tend to include <Qt/...>
434 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
435
436 # Fake normal headers when frameworks are installed... eases life later
437 # on, make sure we use relative links though, as some ebuilds assume
438 # these dirs exist in src_install to add additional files
439 f=${QTHEADERDIR}
440 h=${QTLIBDIR}
441 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
442 f=${f#*/}
443 h=${h#*/}
444 done
445 rdir=${h}
446 f="../"
447 while [[ ${h} == */* ]] ; do
448 f="${f}../"
449 h=${h#*/}
450 done
451 rdir="${f}${rdir}"
452
453 for frw in "${D}${QTLIBDIR}"/*.framework; do
454 [[ -e "${frw}"/Headers ]] || continue
455 f=$(basename ${frw})
456 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
457 dosym "${rdir}"/${f}/Headers "${dest}"
458
459 # Link normal headers as well.
460 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
461 h=$(basename ${hdr})
462 dosym "../${rdir}"/${f}/Headers/${h} \
463 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
464 done
465 done
466 fi
467}
468
469# @FUNCTION: qt4-build_src_install
470# @DESCRIPTION:
471# Perform the actual installation including some library fixes.
472qt4-build_src_install() {
473 setqtenv
474
475 install_directories ${QT4_TARGET_DIRECTORIES}
476 install_qconfigs
477 fix_library_files
478 fix_includes
479
480 # remove .la files since we are building only shared libraries
481 prune_libtool_files
482}
483
484# @FUNCTION: setqtenv
485# @INTERNAL
486setqtenv() {
52 # Set up installation directories 487 # Set up installation directories
53 QTBASEDIR=/usr/$(get_libdir)/qt4
54 QTPREFIXDIR=/usr 488 QTPREFIXDIR=${EPREFIX}/usr
55 QTBINDIR=/usr/bin 489 QTBINDIR=${QTPREFIXDIR}/bin
56 QTLIBDIR=/usr/$(get_libdir)/qt4 490 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
57 QTPCDIR=/usr/$(get_libdir)/pkgconfig 491 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
58 QTDATADIR=/usr/share/qt4
59 QTDOCDIR=/usr/share/doc/qt-${PV} 492 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
60 QTHEADERDIR=/usr/include/qt4 493 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
61 QTPLUGINDIR=${QTLIBDIR}/plugins 494 QTPLUGINDIR=${QTLIBDIR}/plugins
62 QTSYSCONFDIR=/etc/qt4 495 QTIMPORTDIR=${QTLIBDIR}/imports
496 QTDATADIR=${QTPREFIXDIR}/share/qt4
63 QTTRANSDIR=${QTDATADIR}/translations 497 QTTRANSDIR=${QTDATADIR}/translations
498 QTSYSCONFDIR=${EPREFIX}/etc/qt4
64 QTEXAMPLESDIR=${QTDATADIR}/examples 499 QTEXAMPLESDIR=${QTDATADIR}/examples
65 QTDEMOSDIR=${QTDATADIR}/demos 500 QTDEMOSDIR=${QTDATADIR}/demos
501 QMAKE_LIBDIR_QT=${QTLIBDIR}
66 502
67 PLATFORM=$(qt_mkspecs_dir) 503 PLATFORM=$(qt_mkspecs_dir)
504 unset QMAKESPEC
68 505
69 PATH="${S}/bin:${PATH}" 506 export XDG_CONFIG_HOME="${T}"
70 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}"
71
72 if ! version_is_at_least 4.1 $(gcc-version) ; then
73 ewarn "Using a GCC version lower than 4.1 is not supported!"
74 echo
75 ebeep 5
76 fi
77
78 if use custom-cxxflags; then
79 echo
80 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
81 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
82 ewarn "recommend to unset this useflag. But you are free to experiment with it."
83 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
84 ewarn "for breakfast. ;-) "
85 echo
86 fi
87
88} 507}
89 508
90qt4-build_src_unpack() { 509# @FUNCTION: prepare_directories
91 local target targets 510# @USAGE: < directories >
92 for target in configure LICENSE.{GPL2,GPL3} projects.pro \ 511# @INTERNAL
93 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 512# @DESCRIPTION:
94 ${QT4_EXTRACT_DIRECTORIES}; do 513# Generates Makefiles for the given list of directories.
95 targets="${targets} ${MY_P}/${target}" 514prepare_directories() {
515 for x in "$@"; do
516 pushd "${S}"/${x} >/dev/null || die
517 einfo "Running qmake in: ${x}"
518 "${S}"/bin/qmake \
519 "LIBS+=-L${QTLIBDIR}" \
520 "CONFIG+=nostrip" \
521 || die "qmake failed"
522 popd >/dev/null || die
96 done 523 done
97
98 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
99 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets}
100
101 case "${PV}" in
102 4.4.?)
103 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
104 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
105 ;;
106 esac
107
108 # Be backwards compatible for now
109 if [[ $EAPI != 2 ]]; then
110 qt4-build_src_prepare
111 fi
112} 524}
113 525
114qt4-build_src_prepare() { 526# @FUNCTION: build_directories
115 cd "${S}" 527# @USAGE: < directories >
116 528# @INTERNAL
117 if [[ ${PN} != qt-core ]]; then 529# @DESCRIPTION:
118 skip_qmake_build_patch 530# Compiles the code in the given list of directories.
119 skip_project_generation_patch
120 symlink_binaries_to_buildtree
121 fi
122
123 # Bug 172219
124 if !use custom-cxxflags;then
125 # Don't let the user go too overboard with flags.
126 strip-flags
127 replace-flags -O3 -O2
128 fi
129
130 # Bug 253127
131 # Unsupported old gcc versions - hardened needs this :(
132 if [[ $(gcc-major-version) -lt "4" ]] ; then
133 ewarn "Appending -fno-stack-protector to CXXFLAGS"
134 append-cxxflags -fno-stack-protector
135 fi
136
137 # Bug 178652
138 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then
139 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
140 append-flags -fno-gcse
141 fi
142
143
144 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
145 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
146 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
147 -e "s:X11R6/::" \
148 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
149
150 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
151 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
152 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
153 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
154
155}
156
157qt4-build_src_configure() {
158
159 myconf="$(standard_configure_options) ${myconf}"
160
161 echo ./configure ${myconf}
162 ./configure ${myconf} || die "./configure failed"
163}
164
165qt4-build_src_compile() {
166 # Be backwards compatible for now
167 if [[ $EAPI != 2 ]]; then
168 qt4-build_src_configure
169 fi
170
171 build_directories "${QT4_TARGET_DIRECTORIES}"
172}
173
174qt4-build_src_install() {
175 install_directories "${QT4_TARGET_DIRECTORIES}"
176 install_qconfigs
177 fix_library_files
178}
179
180standard_configure_options() {
181 local myconf=""
182
183 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)"
184
185 # Disable visibility explicitly if gcc version isn't 4
186 if [[ "$(gcc-major-version)" -lt "4" ]]; then
187 myconf="${myconf} -no-reduce-exports"
188 fi
189
190 # precompiled headers doesn't work on hardened, where the flag is masked.
191 if use pch; then
192 myconf="${myconf} -pch"
193 else
194 myconf="${myconf} -no-pch"
195 fi
196
197 if use debug; then
198 myconf="${myconf} -debug -no-separate-debug-info"
199 else
200 myconf="${myconf} -release -no-separate-debug-info"
201 fi
202
203 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
204 # ${ARCH}. Therefore we convert it to supported values.
205 case "${ARCH}" in
206 amd64) myconf="${myconf} -arch x86_64" ;;
207 ppc|ppc64) myconf="${myconf} -arch powerpc" ;;
208 x86|x86-*) myconf="${myconf} -arch i386" ;;
209 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch ${ARCH}" ;;
210 hppa|sh) myconf="${myconf} -arch generic" ;;
211 *) die "${ARCH} is unsupported by this eclass. Please file a bug." ;;
212 esac
213
214 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath
215 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
216 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
217 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
218 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
219 -demosdir ${QTDEMOSDIR} -silent -fast
220 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
221 $(use x86-fbsd || echo -reduce-relocations)
222 -nomake examples -nomake demos"
223
224 echo "${myconf}"
225}
226
227build_directories() { 531build_directories() {
228 local dirs="$@"
229 for x in ${dirs}; do 532 for x in "$@"; do
230 cd "${S}"/${x} 533 pushd "${S}"/${x} >/dev/null || die
231 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 534 emake \
232 emake || die "emake failed" 535 AR="$(tc-getAR) cqs" \
536 CC="$(tc-getCC)" \
537 CXX="$(tc-getCXX)" \
538 LINK="$(tc-getCXX)" \
539 RANLIB=":" \
540 STRIP=":"
541 popd >/dev/null || die
233 done 542 done
234} 543}
235 544
545# @FUNCTION: install_directories
546# @USAGE: < directories >
547# @INTERNAL
548# @DESCRIPTION:
549# Runs emake install in the given directories, which are separated by spaces.
236install_directories() { 550install_directories() {
237 local dirs="$@"
238 for x in ${dirs}; do 551 for x in "$@"; do
239 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 552 pushd "${S}"/${x} >/dev/null || die
240 emake INSTALL_ROOT="${D}" install || die "emake install failed" 553 emake INSTALL_ROOT="${D}" install
241 popd >/dev/null || die "Can't popd from ${S}/${x}" 554 popd >/dev/null || die
242 done 555 done
243} 556}
244 557
245# @ECLASS-VARIABLE: QCONFIG_ADD 558# @ECLASS-VARIABLE: QCONFIG_ADD
246# @DESCRIPTION: 559# @DESCRIPTION:
247# List options that need to be added to QT_CONFIG in qconfig.pri 560# List options that need to be added to QT_CONFIG in qconfig.pri
248QCONFIG_ADD="${QCONFIG_ADD:-}" 561: ${QCONFIG_ADD:=}
249 562
250# @ECLASS-VARIABLE: QCONFIG_REMOVE 563# @ECLASS-VARIABLE: QCONFIG_REMOVE
251# @DESCRIPTION: 564# @DESCRIPTION:
252# List options that need to be removed from QT_CONFIG in qconfig.pri 565# List options that need to be removed from QT_CONFIG in qconfig.pri
253QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 566: ${QCONFIG_REMOVE:=}
254 567
255# @ECLASS-VARIABLE: QCONFIG_DEFINE 568# @ECLASS-VARIABLE: QCONFIG_DEFINE
256# @DESCRIPTION: 569# @DESCRIPTION:
257# List variables that should be defined at the top of QtCore/qconfig.h 570# List variables that should be defined at the top of QtCore/qconfig.h
258QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 571: ${QCONFIG_DEFINE:=}
259 572
573# @FUNCTION: install_qconfigs
574# @INTERNAL
575# @DESCRIPTION:
576# Install gentoo-specific mkspecs configurations.
260install_qconfigs() { 577install_qconfigs() {
261 local x 578 local x
262 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 579 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
263 for x in QCONFIG_ADD QCONFIG_REMOVE; do 580 for x in QCONFIG_ADD QCONFIG_REMOVE; do
264 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 581 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
265 done 582 done
266 insinto ${QTDATADIR}/mkspecs/gentoo 583 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
267 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 584 doins "${T}"/${PN}-qconfig.pri
268 fi 585 fi
269 586
270 if [[ -n ${QCONFIG_DEFINE} ]]; then 587 if [[ -n ${QCONFIG_DEFINE} ]]; then
271 for x in ${QCONFIG_DEFINE}; do 588 for x in ${QCONFIG_DEFINE}; do
272 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 589 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
273 done 590 done
274 insinto ${QTHEADERDIR}/Gentoo 591 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
275 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 592 doins "${T}"/gentoo-${PN}-qconfig.h
276 fi 593 fi
277} 594}
278 595
596# @FUNCTION: generate_qconfigs
597# @INTERNAL
598# @DESCRIPTION:
599# Generates gentoo-specific qconfig.{h,pri}.
279generate_qconfigs() { 600generate_qconfigs() {
280 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 601 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
281 local x qconfig_add qconfig_remove qconfig_new 602 local x qconfig_add qconfig_remove qconfig_new
282 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 603 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
283 [[ -f ${x} ]] || continue 604 [[ -f ${x} ]] || continue
284 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 605 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
285 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 606 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
286 done 607 done
287 608
288 # these error checks do not use die because dying in pkg_post{inst,rm} 609 # these error checks do not use die because dying in pkg_post{inst,rm}
289 # just makes things worse. 610 # just makes things worse.
290 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 611 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
291 # start with the qconfig.pri that qt-core installed 612 # start with the qconfig.pri that qtcore installed
292 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 613 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
293 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 614 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
294 eerror "cp qconfig failed." 615 eerror "cp qconfig failed."
295 return 1 616 return 1
296 fi 617 fi
297 618
298 # generate list of QT_CONFIG entries from the existing list 619 # generate list of QT_CONFIG entries from the existing list
299 # including qconfig_add and excluding qconfig_remove 620 # including qconfig_add and excluding qconfig_remove
300 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 621 for x in $(sed -n 's/^QT_CONFIG +=//p' \
301 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 622 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
302 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 623 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
303 done 624 done
304 625
305 # replace the existing QT_CONFIG list with qconfig_new 626 # replace the existing QT_CONFIG list with qconfig_new
306 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 627 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
307 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 628 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
330 "${ROOT}${QTHEADERDIR}" 2>/dev/null 651 "${ROOT}${QTHEADERDIR}" 2>/dev/null
331 fi 652 fi
332 fi 653 fi
333} 654}
334 655
656# @FUNCTION: qt4-build_pkg_postrm
657# @DESCRIPTION:
658# Regenerate configuration when the package is completely removed.
335qt4-build_pkg_postrm() { 659qt4-build_pkg_postrm() {
336 generate_qconfigs 660 generate_qconfigs
337} 661}
338 662
663# @FUNCTION: qt4-build_pkg_postinst
664# @DESCRIPTION:
665# Regenerate configuration, plus throw a message about possible
666# breakages and proposed solutions.
339qt4-build_pkg_postinst() { 667qt4-build_pkg_postinst() {
340 generate_qconfigs 668 generate_qconfigs
341 echo
342 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
343 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
344 ewarn "should recompile the packages providing these plugins. Also, make sure you"
345 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
346 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
347 ewarn
348 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
349 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
350 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
351 ewarn "configuration."
352 ewarn
353 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
354 echo
355} 669}
356 670
671# @FUNCTION: skip_qmake_build
672# @INTERNAL
673# @DESCRIPTION:
674# Patches configure to skip qmake compilation, as it's already installed by qtcore.
357skip_qmake_build_patch() { 675skip_qmake_build() {
358 # Don't need to build qmake, as it's already installed from qt-core
359 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 676 sed -i -e "s:if true:if false:g" "${S}"/configure || die
360} 677}
361 678
362skip_project_generation_patch() { 679# @FUNCTION: skip_project_generation
680# @INTERNAL
681# @DESCRIPTION:
363 # Exit the script early by throwing in an exit before all of the .pro files are scanned 682# Exit the script early by throwing in an exit before all of the .pro files are scanned.
683skip_project_generation() {
364 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 684 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
365 -i "${S}"/configure || die "Sed failed"
366} 685}
367 686
687# @FUNCTION: symlink_binaries_to_buildtree
688# @INTERNAL
689# @DESCRIPTION:
690# Symlinks generated binaries to buildtree, so they can be used during compilation time.
368symlink_binaries_to_buildtree() { 691symlink_binaries_to_buildtree() {
369 for bin in qmake moc uic rcc; do 692 for bin in qmake moc uic rcc; do
370 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 693 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
371 done 694 done
372} 695}
373 696
697# @FUNCTION: fix_library_files
698# @INTERNAL
699# @DESCRIPTION:
700# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
701# moves the *.pc files into the pkgconfig directory.
374fix_library_files() { 702fix_library_files() {
703 local libfile
375 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 704 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
376 if [[ -e ${libfile} ]]; then 705 if [[ -e ${libfile} ]]; then
377 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 706 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
378 fi 707 fi
379 done 708 done
380 709
381 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 710 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
382 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 711 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
383 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
384 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 713 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
385 714
386 # Move .pc files into the pkgconfig directory 715 # Move .pc files into the pkgconfig directory
387
388 dodir ${QTPCDIR} 716 dodir ${QTPCDIR#${EPREFIX}}
389 mv ${libfile} "${D}"/${QTPCDIR}/ \ 717 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
390 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
391 fi 718 fi
392 done 719 done
393 720
394 # Don't install an empty directory 721 # Don't install an empty directory
395 rmdir "${D}"/${QTLIBDIR}/pkgconfig 722 rmdir "${D}"/${QTLIBDIR}/pkgconfig
396} 723}
397 724
725# @FUNCTION: qt_use
726# @USAGE: < flag > [ feature ] [ enableval ]
727# @DESCRIPTION:
728# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
729# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
730# will be used for that. If [enableval] is not specified, it omits the
731# "-${enableval}" part.
398qt_use() { 732qt_use() {
399 local flag="${1}" 733 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
400 local feature="${1}"
401 local enableval=
402
403 [[ -n ${2} ]] && feature=${2}
404 [[ -n ${3} ]] && enableval="-${3}"
405
406 if use ${flag}; then
407 echo "${enableval}-${feature}"
408 else
409 echo "-no-${feature}"
410 fi
411} 734}
412 735
413# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 736# @FUNCTION: qt_mkspecs_dir
737# @RETURN: the specs-directory w/o path
414# @DESCRIPTION: 738# @DESCRIPTION:
415# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 739# Allows us to define which mkspecs dir we want to use.
416# (eutils.eclass), line per line.
417#
418# Example:
419# @CODE
420# pkg_setup() {
421# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
422# ~x11-libs/qt-gui-${PV} qt3support"
423# qt4-build_check_use
424# }
425# @CODE
426
427# Run built_with_use on each flag and print appropriate error messages if any
428# flags are missing
429_qt_built_with_use() {
430 local missing opt pkg flag flags
431
432 if [[ ${1} = "--missing" ]]; then
433 missing="${1} ${2}" && shift 2
434 fi
435 if [[ ${1:0:1} = "-" ]]; then
436 opt=${1} && shift
437 fi
438
439 pkg=${1} && shift
440
441 for flag in "${@}"; do
442 flags="${flags} ${flag}"
443 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
444 flags="${flags}*"
445 else
446 [[ ${opt} = "-o" ]] && return 0
447 fi
448 done
449 if [[ "${flags# }" = "${@}" ]]; then
450 return 0
451 fi
452 if [[ ${opt} = "-o" ]]; then
453 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
454 else
455 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
456 fi
457 return 1
458}
459
460# @FUNCTION: qt4-build_check_use
461# @DESCRIPTION:
462# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
463# USE flags listed.
464#
465# If any of the required USE flags are missing, an eerror will be printed for
466# each package with missing USE flags.
467qt4-build_check_use() {
468 local line missing
469 while read line; do
470 [[ -z ${line} ]] && continue
471 if ! _qt_built_with_use ${line}; then
472 missing=true
473 fi
474 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
475 if [[ -n ${missing} ]]; then
476 echo
477 eerror "Flags marked with an * are missing."
478 die "Missing USE flags found"
479 fi
480}
481
482qt_mkspecs_dir() { 740qt_mkspecs_dir() {
483 # Allows us to define which mkspecs dir we want to use.
484 local spec 741 local spec=
485 742
486 case ${CHOST} in 743 case "${CHOST}" in
487 *-freebsd*|*-dragonfly*) 744 *-freebsd*|*-dragonfly*)
488 spec="freebsd" ;; 745 spec=freebsd ;;
489 *-openbsd*) 746 *-openbsd*)
490 spec="openbsd" ;; 747 spec=openbsd ;;
491 *-netbsd*) 748 *-netbsd*)
492 spec="netbsd" ;; 749 spec=netbsd ;;
493 *-darwin*) 750 *-darwin*)
751 if use aqua; then
752 # mac with carbon/cocoa
753 spec=macx
754 else
755 # darwin/mac with x11
494 spec="darwin" ;; 756 spec=darwin
757 fi
758 ;;
759 *-solaris*)
760 spec=solaris ;;
495 *-linux-*|*-linux) 761 *-linux-*|*-linux)
496 spec="linux" ;; 762 spec=linux ;;
497 *) 763 *)
498 die "Unknown CHOST, no platform choosen." 764 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
499 esac 765 esac
500 766
501 CXX=$(tc-getCXX) 767 case "$(tc-getCXX)" in
502 if [[ ${CXX/g++/} != ${CXX} ]]; then 768 *g++*)
503 spec="${spec}-g++" 769 spec+=-g++ ;;
504 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 770 *icpc*)
505 spec="${spec}-icc" 771 spec+=-icc ;;
506 else 772 *)
507 die "Unknown compiler ${CXX}." 773 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
774 esac
775
776 # Add -64 for 64bit profiles
777 if use x64-freebsd ||
778 use amd64-linux ||
779 use x64-macos ||
780 use x64-solaris ||
781 use sparc64-solaris
782 then
783 spec+=-64
508 fi 784 fi
509 785
510 echo "${spec}" 786 echo "${spec}"
511} 787}
512 788
513case ${EAPI:-0} in 789# @FUNCTION: qt_nolibx11
514 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 790# @INTERNAL
791# @DESCRIPTION:
792# Skip X11 tests for packages that don't need X libraries installed.
793qt_nolibx11() {
794 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
795}
796
515 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 797EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
516esac

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.160

  ViewVC Help
Powered by ViewVC 1.1.20